#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <time.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>

struct bar
{
  char *v;
  char t;
  int u;
};

#include "words/adjvs.h"
#include "words/nouns.h"
#include "words/parts.h"
#include "words/verbs.h"
#include "words/first.h"

#define N(a) (sizeof(a)/sizeof(struct bar))

struct
{
  char t;
  struct bar *l;
  int n;
}
foo[] =
{
  {
  'A', adjvs, N (adjvs) - 1}
  ,
  {
  'N', nouns, N (nouns) - 1}
  ,
  {
  'P', parts, N (parts) - 1}
  ,
  {
  'V', verbs, N (verbs) - 1}
  ,
  {
  'F', first, N (first) - 1}
  ,
  {
  0, NULL, 0}
};

void
sn (void)
{
  struct timeval tv;
  long q;
  gettimeofday(&tv,NULL);

  q=(long) tv.tv_sec;
  q^=(long) tv.tv_usec;
  srand48 (q);
}

float
rn (void)
{
  return drand48 ();
}

struct bar *
choose (char w)
{
  int n;
  float f;
  int m;

  n = 0;

  while (toupper(foo[n].t) != w)
    {
      if (!foo[n].t)
        return NULL;
      n++;
    }


  do
    {
      f = rn () * (float) foo[n].n;
      m = (int) f;
    }
  while ((m >= foo[n].n) || (foo[n].l[m].u));


  foo[n].l[m].u++;

  return &foo[n].l[m];
}


char *
munge (char *fish)
{
  char *buf = malloc (strlen (fish) * 3);
  char *ptr = buf;
  float f;

  while (*fish)
    {
      f = rn ();
      switch (*fish)
        {
        case 'A':
          if (f < 0.5)
            {
              *(ptr++) = 'A';
            }
          else if (f < 0.85)
            {
              *(ptr++) = 'A';
              *(ptr++) = 'A';
            }
          else
            {
              *(ptr++) = 'N';
              *(ptr++) = 'P';
            }
          break;
        case 'N':
          if (f < 0.5)
            {
              *(ptr++) = 'N';
            }
          else
            {
              *(ptr++) = 'A';
              *(ptr++) = 'N';
            }
          break;
        case 'P':
          if (f < 0.5)
            {
              *(ptr++) = 'P';
            }
          else
            {
              *(ptr++) = 'A';
              *(ptr++) = 'P';
            }
          break;
        }
      fish++;
    }
  *ptr = 0;
  return buf;
}



main ()
{
  char *seed = "N";
  char *ptr;
  struct bar *noun;
  int f = 1;

  sn ();

  while (strlen (seed) < 5)
    {
      seed = munge (seed);
    }


  seed[strlen(seed)-1]=0;
  noun = choose ('N');

  if (noun->t=='n') f=0;

  ptr=choose('F')->v;

  putc(toupper(*ptr),stdout);
  ptr++;
  fputs(ptr,stdout);

      putc (' ', stdout);
  

  while (*seed)
    {
      ptr = choose (*seed)->v;

      if (f==1)
        {
          switch (*ptr)
            {
            case 'a':
            case 'e':
            case 'i':
            case 'o':
            case 'u':
              fputs ("an", stdout);
              break;
            case 'h':
              switch (*(ptr + 1))
                {
                case 'a':
                case 'e':
                case 'i':
                case 'o':
                case 'u':
                  fputs ("an", stdout);
                  break;
                default:
                  fputs ("a", stdout);
                  break;
                }
              break;
            default:
              fputs ("a", stdout);
              break;
            }
          putc (' ',stdout);
        }

#if 0
      if (f==2) {
	putc(toupper(*ptr),stdout);
        ptr++;
      }
#endif

      fputs (ptr, stdout);
      putc (' ', stdout);
      seed++;
      if (f)
        f = 0;
    }
  fputs(noun->v,stdout);
  putc ('.',stdout);
  putc ('\n',stdout);

  return 0;
}
